from fastapi import APIRouter, Request, Response
from jsonrpcserver import (
    dispatch as _dispatch,
    method as call,
    Result,
    Success,
    Error,
    InvalidParams,
)


_dispatcher = APIRouter(include_in_schema=False)


@_dispatcher.post(path='/', include_in_schema=False)
async def _rpc(request: Request):
    """JSON RPC 2.0 Dispatcher."""
    return Response(_dispatch(await request.body()))


def get_rpc_dispatcher() -> APIRouter:
    """Get rpc dispatcher."""
    return _dispatcher


__all__ = (
    'get_rpc_dispatcher',
    'call',
    'Result',
    'Success',
    'Error',
    'InvalidParams',
)
